=== modified file 'drizzled/error.cc'
--- drizzled/error.cc	2010-12-30 00:43:20 +0000
+++ drizzled/error.cc	2010-12-30 02:37:34 +0000
@@ -514,8 +514,8 @@
   ADD_ERROR_MESSAGE(ER_INVALID_CAST_TO_BOOLEAN, N_("Invalid cast to BOOLEAN: '%s'."));
 
   // ASSERT Message
-  ADD_ERROR_MESSAGE(ER_ASSERT, N_("Assertion failed: '%s'."));
-  ADD_ERROR_MESSAGE(ER_ASSERT_NULL, N_("Assertion failed, result was NULL."));
+  ADD_ERROR_MESSAGE(ER_ASSERT, N_("Assertion '%s' failed."));
+  ADD_ERROR_MESSAGE(ER_ASSERT_NULL, N_("Assertion '%s' failed, the result was NULL."));
 
   // Some old error values use the same strings as some new error values.
   ADD_ERROR_MESSAGE(EE_FILENOTFOUND, find(ER_FILE_NOT_FOUND));

=== modified file 'plugin/utility_functions/assert.cc'
--- plugin/utility_functions/assert.cc	2010-12-30 00:43:20 +0000
+++ plugin/utility_functions/assert.cc	2010-12-30 02:37:34 +0000
@@ -33,18 +33,19 @@
 {
   if (not args[0]->val_bool())
   {
-    drizzled::String _res;
-    drizzled::String *res;
+    drizzled::String res;
+    args[0]->print(&res, QT_ORDINARY);
+
+    assert(res.c_ptr());
 
     if (args[0]->is_null())
     {
-      drizzled::my_error(ER_ASSERT_NULL, MYF(0));
-
-      return false;
-    }
-
-    res= args[0]->val_str(&_res);
-    drizzled::my_error(ER_ASSERT, MYF(0), res->c_str());
+      drizzled::my_error(ER_ASSERT_NULL, MYF(0), res.c_ptr());
+    }
+    else
+    {
+      drizzled::my_error(ER_ASSERT, MYF(0), res.c_ptr());
+    }
 
     return false;
   }

=== modified file 'plugin/utility_functions/tests/r/assert.result'
--- plugin/utility_functions/tests/r/assert.result	2010-12-30 00:43:20 +0000
+++ plugin/utility_functions/tests/r/assert.result	2010-12-30 02:37:34 +0000
@@ -23,34 +23,36 @@
 (SELECT ASSERT(TRUE))
 1
 SELECT ASSERT(FALSE);
-ERROR HY000: Assertion failed: 'FALSE'.
+ERROR HY000: Assertion 'FALSE' failed.
 SELECT ASSERT(ASSERT(FALSE));
-ERROR HY000: Assertion failed: 'FALSE'.
+ERROR HY000: Assertion 'FALSE' failed.
 SELECT ASSERT(NULL);
-ERROR HY000: Assertion failed, result was NULL.
+ERROR HY000: Assertion 'NULL' failed, the result was NULL.
 SELECT ASSERT(1 -1);
-ERROR HY000: Assertion failed: '0'.
+ERROR HY000: Assertion '(1 - 1)' failed.
 SELECT ASSERT(1 < 0);
-ERROR HY000: Assertion failed: '0'.
+ERROR HY000: Assertion '(1 < 0)' failed.
 SELECT (SELECT (SELECT (ASSERT(1 -1))));
-ERROR HY000: Assertion failed: '0'.
+ERROR HY000: Assertion '(1 - 1)' failed.
 SELECT 1 FROM (SELECT ASSERT(FALSE)) failure;
-ERROR HY000: Assertion failed: 'FALSE'.
+ERROR HY000: Assertion 'FALSE' failed.
 SELECT (SELECT 1) UNION SELECT (SELECT ASSERT(FALSE));
-ERROR HY000: Assertion failed: 'FALSE'.
+ERROR HY000: Assertion 'FALSE' failed.
 SELECT (SELECT ASSERT(FALSE)) UNION SELECT (SELECT ASSERT(FALSE));
-ERROR HY000: Assertion failed: 'FALSE'.
+ERROR HY000: Assertion 'FALSE' failed.
 SELECT (SELECT ASSERT(FALSE)) UNION SELECT (SELECT 1);
-ERROR HY000: Assertion failed: 'FALSE'.
+ERROR HY000: Assertion 'FALSE' failed.
+select ASSERT(IF((0 > 1),1, NULL));
+ERROR HY000: Assertion 'if((0 > 1),1,NULL)' failed, the result was NULL.
 CREATE TABLE t1 (a int);
 SELECT ASSERT(COUNT(a)) FROM t1;
-ERROR HY000: Assertion failed: '0'.
+ERROR HY000: Assertion 'count(`test`.`t1`.`a`)' failed.
 INSERT INTO t1 VALUES ();
 SELECT ASSERT(COUNT(*)) FROM t1;
 ASSERT(COUNT(*))
 1
 SELECT ASSERT(COUNT(a)) FROM t1;
-ERROR HY000: Assertion failed: '0'.
+ERROR HY000: Assertion 'count(`test`.`t1`.`a`)' failed.
 DROP table t1;
 CREATE TABLE t1 AS SELECT ASSERT(TRUE);
 SELECT * from t1;
@@ -58,7 +60,7 @@
 1
 DROP TABLE t1;
 CREATE TABLE t1 AS SELECT ASSERT(FALSE);
-ERROR HY000: Assertion failed: 'FALSE'.
+ERROR HY000: Assertion 'FALSE' failed.
 SELECT ASSERT(COUNT(*) = 0) FROM DATA_DICTIONARY.TABLES WHERE TABLE_NAME="t1" AND TABLE_SCHEMA=SCHEMA();
 ASSERT(COUNT(*) = 0)
 1

=== modified file 'plugin/utility_functions/tests/t/assert.test'
--- plugin/utility_functions/tests/t/assert.test	2010-12-30 00:43:20 +0000
+++ plugin/utility_functions/tests/t/assert.test	2010-12-30 02:37:34 +0000
@@ -40,6 +40,9 @@
 --error ER_ASSERT
 SELECT (SELECT ASSERT(FALSE)) UNION SELECT (SELECT 1);
 
+--error ER_ASSERT_NULL
+select ASSERT(IF((0 > 1),1, NULL));
+
 
 # Look at assertions based on table result return
 

